<?php
/**
 * Скрипт проверки трекбеков из базы данных WordPress.
 * Находит все трекбеки (не отмеченные как спам),
 * получает страницу, на которую ссылается трекбек и
 * ищет обратную ссылку.
 * Если ссылки нет - трекбек заносится в отчет, который отправляется
 * владельцу ресурса.
 *     
 * @author Стаценко Владимир
 * @version 1.0 beta
 * @link http://www.simplecoding.org  
 */

define('SITE_URL', 'your_blog_url'); //URL, который нужно проверять

/**
 * Настройки подключения к БД
 */ 

define('DB_NAME', 'your_db_name');
define('DB_HOST', 'your_db_host');
define('DB_USER', 'your_db_user');
define('DB_PASS', 'your_db_pass');
define('DB_TABLE_PREFIX', 'wp_'); //измените, если вы используете другой префикс таблиц

/**
 * Адрес почты для отправки отчета
 */
define('MAIL_ADDRESS', 'your_email');

$log = '';

//подключаемся к базе
$link = mysql_connect(DB_HOST, DB_USER, DB_PASS)
    or die("Could not connect : " . mysql_error());
//выбираем БД
mysql_select_db(DB_NAME)
    or die("Could not select database");

// получаем список трекбеков (не отмеченных как спам, с ними будет разбираться
// Akismet)
$qFindTrackbacks = 'SELECT * FROM '.DB_TABLE_PREFIX.
    'comments WHERE comment_type="trackback" AND comment_approved<>"spam"';
$result = mysql_query($qFindTrackbacks)
    or die("Trackback search failed : " . mysql_error());

//------------- ищем обратные ссылки ---------------------//

//инициализация cURL
$ch = curl_init();
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

while ($curTrackback = mysql_fetch_array($result, MYSQL_ASSOC)) {
    curl_setopt($ch, CURLOPT_URL, $curTrackback['comment_author_url']);
    $page = curl_exec($ch);
    if ($page != null) {
        $log .= 'Receive page '.$curTrackback['comment_author_url'].'\n<br />';
    }
    //проверяем наличие обратной ссылки
    if (substr_count($page, SITE_URL) < 1) {
        //добавляем запись о том, что найден подозрительный трекбек
        $log .= 'Found trackback without backlink : '.$curTrackback['comment_author_url'].'\n<br />';
    }
}

curl_close($ch);

//закрываем соединение
mysql_close($link);

//отправляем письмо с отчетом
if ($log == '') {
    $log .= 'Bad trackbacks not found';
}
mail(MAIL_ADDRESS, 'Trackback search', $log, 'From: Trackback checker script')
    or die("Could not send report");

//скрипт нормально завершил работу
exit(0);
?>